<?php
/**
 *    SmilePay 金流中心-Ecmall付款模組
 *    @author    Hank,Hsu
 *    @date    2014/3/20
 */
class smilepay_ibonPayment extends BasePayment
{
    /* smilepay api */
    var $_gateway   =   'https://www.smilepay.net/';
    var $_code      =   'smilepay_ibon';
    
    function get_payform($order_info)
    {
       
        /* 商店代號 */
        $Dcvc = $this->_config['smilepay_ibon_Dcvc'];
        $Rvg2c = $this->_config['smilepay_ibon_Rvg2c'];		  
        /* 檢查碼 */
 		    $Verifykey = $this->_config['smilepay_ibon_Verifykey'];
        /* 繳款期限 */
 		    $LimitDay = $this->_config['smilepay_ibon_LimitDay'];
         if ($LimitDay=="")
              $LimitDay=6 ;  
         				
        /* 商品名称 可註解*/
        //$Od_sob = $this->_get_subject($order_info);
        
        /* 總金额 */
        $Amount = $order_info['order_amount'] ;           
        $Data_id = $this->_get_trade_sn($order_info);    
	       /*買家email*/
        $email = $order_info['buyer_email'] ;	
        /* 返回的路径 */
		    $bk_posturl =$this->_create_notify_url($order_info['order_id']);  //付款結果回傳位址
		 
        $roturl    = $this->_create_return_url($order_info['order_id']);   //付款完成導向地址
		        
        /* 交易参数 */
        $post_str ='Dcvc='.$Dcvc.
                    '&Rvg2c='.$Rvg2c.
                    '&Pay_zg=4'.
                    '&Pay_gdry=TW'.                    
                  	'&Verify_key='.$Verifykey.
                  	//'&Od_sob='.$Od_sob.
                    '&Email='.$email.                      
                  	'&Data_id='.$Data_id.
                  	'&Amount='.round($Amount).
                  	'&Deadline_date='.date("Y/m/d",mktime(0,0,0,date("m"),date("d")+$LimitDay,date("Y"))).
                  	'&Deadline_time=23:59:59'.                  	
                  	'&Roturl_status=ecmall'.
                  	'&Roturl='.urlencode($bk_posturl);
                    //var_dump($post_str);
                    
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,'http://ssl.smse.com.tw/api/sppayment.asp');
        curl_setopt($ch, CURLOPT_VERBOSE, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,$post_str);
        $strAuth = curl_exec($ch);
        if (curl_errno($ch)) {
                	$strAuth = false;
        }
        curl_close($ch);
        
      if($strAuth) {
      	   // 分解字串
      	   //var_dump($strAuth);
        		$xml = simplexml_load_string($strAuth);
      			$Status = $xml->Status;
      			
            if ($Status=="1") {   
               (strlen($xml->PayEndDate) >8 ) ? $xmlPayEndDate=$xml->PayEndDate : $xmlPayEndDate="" ;                     
               $params = array(
                        'IbonNo='.$xml->IbonNo,
                        'PayEndDate='.urlencode($xmlPayEndDate),
                        'Amount='.$xml->Amount,
                        'Data_id='.$xml->Data_id,
                        'Status='.$xml->Status,
                
               );                           
            }else{    
               $params = array(
                    'Status='.$xml->Status,
                    'Desc='.$xml->Desc,
            
               );   
            }
      } else {
          $params = array(
            'Status=-1000',
            'Desc=取號失敗',    
          );     
      }                
            
            
     echo '	
        <form name="smilepay" method="post" action="'.$roturl.'">
        <input type="hidden" name="parms" value="'.implode("&",$params).'">
        <input type="submit" value="Next" > 
        </form>
        <script language=javascript>
        document.forms.smilepay.submit();
        </script>';
        exit;
    }
    
    /**
     *    返回通知结果
     * 
     */ 
    function verify_notify($order_info, $strict = false)
    { 
  	  if (empty($order_info)){
  			$this->_error('order_info_empty');
  			return false;
  		}
    
  		/*--START顯示繳款資訊--*/  
      parse_str(urldecode($_REQUEST[parms]), $notify);	     
  		if(!empty($_REQUEST[parms]) && $notify['Status']!="1") {
  			  
          $this->_error("Errcode:".$notify['Status']."<br >".$notify['Desc']  );
          return false;
      }
              
      if(!empty($_REQUEST[parms]) && $notify['Status'] =="1"){
          $html_template=	'<script type="text/javascript">window.onload = function () {  
          var htmlsp = "<h4><br><font color=red>尚未付款完成<br >此<font color=blue>'.$notify['Data_id'].'</font> 訂單繳費資料：</font><br>7-11 ibon 代碼: <font color=blue>'.$notify['IbonNo'].'</font><br>金額: <font color=blue>'.abs($notify['Amount']).'</font>元<br>繳費期限：<font color=blue>'.$notify['PayEndDate'].'</font></h4>";
          $(".succeed").html(htmlsp);}</script>';             
          echo $html_template;
          return array(
               'target'    =>  ORDER_FINISHED,
          );      
      }
      /*--END顯示繳款資訊--*/
      
         
    	/*--START繳款通知--*/  
  		if($_REQUEST['Amount'] >0 && $_REQUEST['act']=="notify" ) {
         $Classif= $_REQUEST['Classif'];
         $Data_id= $_REQUEST['Data_id'];
         $Amount =  $_REQUEST['Amount'];    
         $Smseid       = $_REQUEST['Smseid'];
         $Mid_smilepay =  $_REQUEST['Mid_smilepay'];
             
             
         //是否啟用商家驗證參數
         $i_Mid = $this->_config['smilepay_ibon_i_Mid'];
         $Mid = $this->_config['smilepay_ibon_Mid'];
  			 if($i_Mid=="yes" ){
             if(!$this->midfun($Mid,$Amount,$Smseid,$Mid_smilepay)){      
                  $this->_error('sign_inconsistent');
  			          return false;
             }     
         }                                                       		   
  		    // 通知中的订单与欲改变的订单不一致 	
         if ($order_info['out_trade_sn'] != $Data_id){            		     
            $this->_error('order_inconsistent');  			
            return false;
         }
         // 支付的金额与实际金额不一致 
    		 if (abs($order_info['order_amount']) != abs($Amount)){  		      
            $this->_error('price_inconsistent');  			
            return false;
         }         
         // 支付的金额与实际金额相符,付款類別相符  
    		 if ((abs($order_info['order_amount']) == abs($Amount)) && ($Classif == 'E' || $Classif == 'L') ){
            return array(
               'target'    =>  ORDER_ACCEPTED,
            );
         }else{         
            $this->_error('notify_unauthentic');
            return false;
         }
           
    	} else{
         //誤傳通知回傳FALSE，因預設回傳TURE造成訂單取消狀態，無法銷案
         return false;
      }
      /*--END繳款通知--*/  
      
	}
    
    function verify_result($result) {
    	  if ($result) 
        	echo "ecmall";
        else   
         	echo "fail";
    }
    
   // compute Mid  (設定值,金額,追碼,post值)    
  function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
    $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
    $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
    $dtotal=$Mid_value. $Amount. $Smseid;                              
    
    $i = 1;
    $sum = strlen($dtotal);
    $etemp=0;      
    while ($i <= $sum)
    {
      $ep = substr($dtotal,$i,1);
      $etemp = $etemp + $ep;                
      $i=$i+2;
    }                
    
    $i = 0;  
    $otemp=0;          
    while ($i <= $sum)
    {                                              
      $op = substr($dtotal,$i,1);
      $otemp = $otemp + $op;
      $i=$i+2;
    } 
    
    $mid=($etemp*3)+($otemp*9);
  
    if($Mid_smilepay == $mid){
      return true;
    }else{
      return false;
    }       
  }  
        
}
?>